## golang-github-roaringbitmap-roaring 0.4.7

=== Makefile ===
.PHONY: help all test format fmtcheck vet lint     qa deps clean nuke rle backrle ser fetch-real-roaring-datasets








# Display general help about this command
help:
	@echo ""
	@echo "The following commands are available:"
	@echo ""
	@echo "    make qa          : Run all the tests"
	@echo "    make test        : Run the unit tests"
	@echo ""
	@echo "    make format      : Format the source code"
	@echo "    make fmtcheck    : Check if the source code has been formatted"
	@echo "    make vet         : Check for suspicious constructs"
	@echo "    make lint        : Check for style errors"
	@echo ""
	@echo "    make deps        : Get the dependencies"
	@echo "    make clean       : Remove any build artifact"
	@echo "    make nuke        : Deletes any intermediate file"
	@echo ""
	@echo "    make fuzz-smat   : Fuzzy testing with smat"
	@echo "    make fuzz-stream : Fuzzy testing with stream deserialization"
	@echo "    make fuzz-buffer : Fuzzy testing with buffer deserialization"
	@echo ""

# Alias for help target
all: help
test:
	go test
	go test -race -run TestConcurrent*
# Format the source code
format:
	@find ./ -type f -name "*.go" -exec gofmt -w {} \;

# Check if the source code has been formatted
fmtcheck:
	@mkdir -p target
	@find ./ -type f -name "*.go" -exec gofmt -d {} \; | tee target/format.diff
	@test ! -s target/format.diff || { echo "ERROR: the source code has not been formatted - please use 'make format' or 'gofmt'"; exit 1; }

# Check for syntax errors
vet:
	GOPATH=$(GOPATH) go vet ./...

# Check for style errors
lint:
	GOPATH=$(GOPATH) PATH=$(GOPATH)/bin:$(PATH) golint ./...





# Alias to run all quality-assurance checks
qa: fmtcheck test vet lint

# --- INSTALL ---

# Get the dependencies
deps:
	GOPATH=$(GOPATH) go get github.com/smartystreets/goconvey/convey
	GOPATH=$(GOPATH) go get github.com/willf/bitset
	GOPATH=$(GOPATH) go get github.com/golang/lint/golint
	GOPATH=$(GOPATH) go get github.com/mschoch/smat
	GOPATH=$(GOPATH) go get github.com/dvyukov/go-fuzz/go-fuzz
	GOPATH=$(GOPATH) go get github.com/dvyukov/go-fuzz/go-fuzz-build
	GOPATH=$(GOPATH) go get github.com/glycerine/go-unsnap-stream
	GOPATH=$(GOPATH) go get github.com/philhofer/fwd
	GOPATH=$(GOPATH) go get github.com/jtolds/gls

fuzz-smat:
	go test -tags=gofuzz -run=TestGenerateSmatCorpus
	go-fuzz-build -func FuzzSmat github.com/RoaringBitmap/roaring
	go-fuzz -bin=./roaring-fuzz.zip -workdir=workdir/ -timeout=200


fuzz-stream:
	go-fuzz-build -func FuzzSerializationStream github.com/RoaringBitmap/roaring
	go-fuzz -bin=./roaring-fuzz.zip -workdir=workdir/ -timeout=200


fuzz-buffer:
	go-fuzz-build -func FuzzSerializationBuffer github.com/RoaringBitmap/roaring
	go-fuzz -bin=./roaring-fuzz.zip -workdir=workdir/ -timeout=200

# Remove any build artifact
clean:
	GOPATH=$(GOPATH) go clean ./...

# Deletes any intermediate file
nuke:
	rm -rf ./target
	GOPATH=$(GOPATH) go clean -i ./...

rle:
	cp rle.go rle16.go
	perl -pi -e 's/32/16/g' rle16.go
	cp rle_test.go rle16_test.go
	perl -pi -e 's/32/16/g' rle16_test.go

backrle:
	cp rle16.go rle.go
	perl -pi -e 's/16/32/g' rle.go
	perl -pi -e 's/2032/2016/g' rle.go

ser: rle
	go generate

cover:
	go test -coverprofile=coverage.out
	go tool cover -html=coverage.out

fetch-real-roaring-datasets:
	# pull github.com/RoaringBitmap/real-roaring-datasets -> testdata/real-roaring-datasets
	git submodule init
	git submodule update

=== debian/changelog ===
golang-github-roaringbitmap-roaring (0.4.7-1) unstable; urgency=medium

  * Initial release (Closes: #900211)

 -- Alexandre Viau <aviau@debian.org>  Sun, 27 May 2018 13:11:52 -0400

=== debian/control ===
Source: golang-github-roaringbitmap-roaring
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper (>= 11),
               dh-golang,
               golang-any,
               golang-github-smartystreets-goconvey-dev,
               golang-github-tinylib-msgp-dev,
               golang-github-glycerine-go-unsnap-stream-dev,
               golang-github-willf-bitset-dev
Standards-Version: 4.1.4
Homepage: https://github.com/RoaringBitmap/roaring
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-roaringbitmap-roaring
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-roaringbitmap-roaring.git
XS-Go-Import-Path: github.com/RoaringBitmap/roaring
Testsuite: autopkgtest-pkg-go

Package: golang-github-roaringbitmap-roaring-dev
Architecture: all
Depends: ${misc:Depends},
         golang-github-smartystreets-goconvey-dev,
         golang-github-tinylib-msgp-dev,
         golang-github-glycerine-go-unsnap-stream-dev,
         golang-github-willf-bitset-dev
Description: Roaring bitmaps in Go
 This is a go version of the Roaring bitmap data structure.
 .
 Roaring bitmaps are found to work well in many important applications:
 .
 Use Roaring for bitmap compression whenever possible. Do not
 use other bitmap compression methods (Wang et al., SIGMOD 2017
 (http://db.ucsd.edu/wp-content/uploads/2017/03/sidm338-wangA.pdf))

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/golang-github-roaringbitmap-roaring-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/RoaringBitmap/roaring/tags .*/v?(\d\S*)\.tar\.gz

## golang-github-roaringbitmap-roaring 0.4.21

=== debian/changelog ===
golang-github-roaringbitmap-roaring (0.4.21-2) unstable; urgency=medium

  * Team upload

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Shengjing Zhu ]
  * Update uscan watch file version to 4
  * Update section to golang
  * Update maintainer address to team+pkg-go@tracker.debian.org
  * Add Rules-Requires-Root
  * Add Multi-Arch hint
  * Drop unused dependency golang-github-smartystreets-goconvey-dev
  * Replace golang-github-willf-bitset-dev with
    golang-github-bits-and-blooms-bitset-dev

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 01 Feb 2023 01:15:09 +0800

golang-github-roaringbitmap-roaring (0.4.21-1) unstable; urgency=medium

  * Team upload.
  * New upstream release. Closes: #952196.
    - Build-Depends: golang-github-stretchr-testify-dev
  * Standards-Version: 4.5.0
  * debhelper compatibility level 12

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Mar 2020 18:50:36 +0800

=== debian/control ===
Source: golang-github-roaringbitmap-roaring
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-bits-and-blooms-bitset-dev,
               golang-github-glycerine-go-unsnap-stream-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tinylib-msgp-dev
Standards-Version: 4.6.2
Homepage: https://github.com/RoaringBitmap/roaring
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-roaringbitmap-roaring
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-roaringbitmap-roaring.git
XS-Go-Import-Path: github.com/RoaringBitmap/roaring
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: golang-github-roaringbitmap-roaring-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-bits-and-blooms-bitset-dev,
         golang-github-glycerine-go-unsnap-stream-dev,
         golang-github-tinylib-msgp-dev,
         ${misc:Depends}
Description: Roaring bitmaps in Go
 This is a go version of the Roaring bitmap data structure.
 .
 Roaring bitmaps are found to work well in many important applications:
 .
 Use Roaring for bitmap compression whenever possible. Do not
 use other bitmap compression methods (Wang et al., SIGMOD 2017
 (http://db.ucsd.edu/wp-content/uploads/2017/03/sidm338-wangA.pdf))

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/golang-github-roaringbitmap-roaring-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/RoaringBitmap/roaring/tags .*/v?(\d\S*)\.tar\.gz
